// Vertex Shader  file "shadername.vert"

#version 150 core

uniform mat4 PVM_mat;

uniform mat4 proj_mat;
uniform mat4 view_mat;
uniform mat4 model_mat;
uniform mat4 normal_mat;

uniform vec3 ambient;
uniform vec3 light;
uniform vec3 intensity;
uniform vec3 viewing;

in vec4 in_position;
in vec3 in_normal;
in vec3 in_colour;

uniform float diffuse;
uniform float specular;
uniform float shininess;

out vec3 colour;

void main(void)
{
	//gl_Position = PVM_mat * in_position;
	vec4 newNormal = vec4(in_normal, 1);
	newNormal = normal_mat * newNormal;
	vec3 normal = vec3(newNormal);
	
	//gl_Position = glm::mat4(1.0f) * in_position;
	gl_Position = proj_mat * view_mat * model_mat * in_position;


	//gl_Position = proj_mat * view_mat * in_position;
	vec3 L = normalize(light);
	vec3 N = normalize(normal);
	vec3 R = normalize(-reflect(L,N));
	vec3 V = normalize(viewing);
	vec3 colInt = ambient * in_colour + diffuse * intensity * max(dot(N, L), 0.0) * in_colour + specular * intensity * pow(max(dot(R, V), 0.0), shininess);
	
	//gl_Position = vec4(in_position.xy, 0.0, 1.0);

	//gl_Position = proj_mat * view_mat * vec4(in_position.xy, -5.0, 1.0);
	
	colour = colInt;
	//colour = in_normal;//*0.5+0.5;
}
