#version 330

uniform vec3 ambient;
uniform vec3 light;
uniform vec3 intensity;

uniform float diffuse;

uniform bool torte;

uniform	sampler2D texUnit;
uniform sampler2DShadow shadow_map; // shadow map is just a texture

in vec3 out_normal;
in vec2 texCoord;
in vec4 sm_coord;
out vec4 out_texture;

void main()
{
	vec3 colour;
	vec3 oldColour;
	
	vec3 L = normalize(light);
	vec3 N = normalize(out_normal);
	//float shadow = textureProj(shadow_map, sm_coord);
	float sum = 0;
	sum += textureProjOffset(shadow_map, sm_coord, ivec2(-1, -1));
	sum += textureProjOffset(shadow_map, sm_coord, ivec2(-1, 1));
	sum += textureProjOffset(shadow_map, sm_coord, ivec2(1, -1));
	sum += textureProjOffset(shadow_map, sm_coord, ivec2(1, 1));
	float shadow = sum * 0.25;

	oldColour = texture2D(texUnit, texCoord).rgb;
	vec3 newAmbient = ambient;

	if (torte && N.y > 0.9) {
		oldColour = vec3(1.f, 1.f, 1.f);
		newAmbient = vec3(0.6, 0.6, 0.6);
	}

	

	vec3 colInt = newAmbient + diffuse* shadow* intensity * max(dot(N, L), 0.0);

	colour = colInt * oldColour;

	out_texture = vec4(colour, 1.f);
}
